// PERSONAL HELL: reworked edition

local BASE_DISTANCE = 450
local mapscale = FRACUNIT
local MAX_DISTANCE = BASE_DISTANCE * mapscale
local MAX_DISTANCE_THRESHOLD = BASE_DISTANCE * mapscale

addHook("NetVars", function(sync)
	BASE_DISTANCE = sync(BASE_DISTANCE)
	mapscale = sync(mapscale)
	MAX_DISTANCE = sync(MAX_DISTANCE)
	hcombi.leveltime_on = sync($)
end)

// kill every gargoyle a player *would* have
addHook("ThinkFrame", function()
	if leveltime == 2 then
		for player in players.iterate do
			player.gargoyle = nil
		end
	end
end)

// hook stuff

// Return either a gargoyle or a partner's mobj.
hcombi.ReturnPartner = function(player)
	// Why would i need has_partner if i can tell that by simply checking combi_p???
	// If you author and reading this, no offense, but this code is a mess honestly
	//
	// haya months late, this was a fucking mess, kill it
	if player.combi_p and player.combi_p.valid and not player.combi_p.spectator then
		return player.combi_p.mo
	end
	
	if player.gargoyle == nil then 
		// summon gargoyle >:)))))
		player.gargoyle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + 192*mapscale, MT_GARGOYLE)
		player.gargoyle.target = player.mo
		hcombi.RefreshRingBit(player)
	else
		if not player.gargoyle.valid then
			player.gargoyle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + 192*mapscale, MT_GARGOYLE)
			player.gargoyle.target = player.mo
			hcombi.RefreshRingBit(player)
		end
	end
	return player.gargoyle
end

// Thinker for summoning the ringbits.
hcombi.RingBitThink = function(player, has_partner)
	local partner = hcombi.ReturnPartner(player)
	
	hcombi.PlaceRingBit(player)
end

hcombi.PullVarThink = function(player, has_partner)
	local partner = hcombi.ReturnPartner(player)
	local plymo = player.mo
	
	// if we already have our pull hook set, and returns true, override everything
	if (hookLib.RunHook("CombiPull", partner, plymo))
		-- overwrite behaviour
		return
	end
	
	-- set our pull
	plymo.pull_xy = FRACUNIT
	partner.pull_xy = FRACUNIT
	plymo.pull_z = FRACUNIT
	partner.pull_z = FRACUNIT
	
	// if we are moving
	if player.cmd.buttons & BT_ACCELERATE then
		plymo.pull_xy = $+FRACUNIT/2
	end
	if player.cmd.buttons & BT_BRAKE then
		plymo.pull_xy = $+FRACUNIT
	end
	if not P_IsObjectOnGround(plymo) then
		if not has_partner then
			partner.pull_z = 0
			partner.pull_xy = 0
		else
			plymo.pull_z = $+FRACUNIT*2
		end
		
		-- Only increase when one of partners is on ground to avoid false positives
		if partner and partner.valid and P_IsObjectOnGround(partner) then
			plymo.cur_airtime = ($ or 0) + 1
		end
		
		if plymo.cur_airtime - (partner.cur_airtime or 0) > 3*TICRATE then
			P_SetOrigin(plymo, partner.x, partner.y, partner.z + 100*mapscale)
			plymo.cur_airtime = 0
			partner.cur_airtime = 0
			plymo.color = plymo.player.skincolor
			plymo.colorized = false
		elseif plymo.cur_airtime - (partner.cur_airtime or 0) > 2*TICRATE then
			if leveltime % 2 == 0 then
				plymo.color = SKINCOLOR_WRISTWATCH
				plymo.colorized = true
			else
				plymo.color = plymo.player.skincolor
				plymo.colorized = false
			end
		end
	else
		plymo.cur_airtime = ($ or 0)
		if plymo.cur_airtime - (partner.cur_airtime or 0) > 2*TICRATE then
			plymo.color = plymo.player.skincolor
			plymo.colorized = false
			plymo.cur_airtime = 0
		end
		plymo.cur_airtime = 0
			
		if partner.z <= partner.floorz and plymo.z + 200*mapscale > partner.z then
			partner.pull_z = 0
		end	
	end

	// if partner is moving
	if player.combi ~= nil then
		if partner.player.cmd.buttons & BT_ACCELERATE then
			partner.pull_xy = $+FRACUNIT/2
		end
		if partner.player.cmd.buttons & BT_BRAKE then
			partner.pull_xy = $+FRACUNIT
		end
		if partner.z > partner.floorz and partner.pull_z then
			partner.pull_z = $+FRACUNIT*2
		end
	end
end

// PlayerThink doesnt work on this world.
local function MasterEmeraldSyncer(p)
	if not (p.mo and p.mo.valid) or p.spectator then return end
	if not p.masteremerald then return end // we need to actually have it enabled, dingus

	local pks = p.kartstuff
	local EM = p.masteremerald
	if EM.super and EM.sparkle == 1 then
		-- END IT
		p.combi_p.mo.color = p.combi_p.skincolor
		p.combi_p.masteremerald.sparkle = 0
		p.combi_p.kartstuff[k_invincibilitytimer] = 0
	end
	if EM.super and not p.combi_p.masteremerald.super then
		p.combi_p.masteremerald.super = 1
		p.combi_p.masteremerald.sparkle = max($, EM.sparkle)
		p.combi_p.kartstuff[k_invincibilitytimer] = max($, pks[k_invincibilitytimer])
	end
end

// now stop asking me about this toast.
local function ReturnPowerInfo(player, sparkle)
	// HQ interop, both new and old... hopefully.
	if HugeQuest then
		if sparkle and CV_FindVar("hq_sparkle").value  then
			if not player.hugequest then
				return player.sparkle
			else
				return player.hugequest.sparkle
			end
			return player.kartstuff[k_invincibilitytimer]
		end
		if not CV_FindVar("hq_huge").value then
			return player.kartstuff[k_growshrinktimer]
		end
		if not player.hugequest then
			return player.huge
		else
			return player.hugequest.huge
		end
	end
	// just return this.
	return player.kartstuff[k_growshrinktimer]
end

local function SetPowerInfo(player, sparkle, val)
	// HQ interop, both new and old... hopefully.
	if HugeQuest then
		if sparkle and CV_FindVar("hq_sparkle").value  then
			if not player.hugequest then
				player.sparkle = val
			else
				player.hugequest.sparkle = val
			end
			player.kartstuff[k_invincibilitytimer] = val
			return
		end
		if not CV_FindVar("hq_huge").value then
			player.kartstuff[k_growshrinktimer] = val
			return
		end
		if not player.hugequest then
			player.huge = val
			return
		else
			player.hugequest.huge = val
			return
		end
	end
	// just return this.
	player.kartstuff[k_growshrinktimer] = val
end

// various powerup stuff and other information
hcombi.PlayerDataThink = function(player, has_partner)
	local partner = hcombi.ReturnPartner(player)
	local plymo = player.mo
	
	// if we already have our pull hook set, and returns true, override everything
	if (hookLib.RunHook("CombiPData", partner, plymo))
		-- overwrite behaviour
		return
	end
	
	if player.combi ~= nil then
		if ReturnPowerInfo(player) < -2 and ReturnPowerInfo(partner.player) >= -2 then
			SetPowerInfo(player, false, -2)
		elseif ReturnPowerInfo(player) > 0 then
			SetPowerInfo(partner.player, false, max(ReturnPowerInfo(partner.player), ReturnPowerInfo(player)))
			
			partner.player.mo.destscale = max(player.mo.destscale, $)
			partner.player.mo.scalespeed = max(player.mo.scalespeed, $)
		end
		
		for _, prop in ipairs({k_sneakertimer, k_invincibilitytimer, k_driftboost, k_startboost, k_hyudorotimer}) do
			player.kartstuff[prop] = max($, partner.player.kartstuff[prop])
		end
		player.realtime = min($, partner.player.realtime)
		// Super interop only for HQ versions > Lisa
		if HugeQuest and player.hugequest then
			if partner.player.hugequest.super and not player.hugequest.super then
				-- sync both so that we dont get any weird side effects
				player.hugequest.huge = partner.player.hugequest.huge
				player.hugequest.sparkle = partner.player.hugequest.sparkle
				player.hugequest.super = 1
				//player.mo.sparkle = max($, players[player.combi].mo.sparkle)
				player.kartstuff[k_invincibilitytimer] = partner.player.kartstuff[k_invincibilitytimer]
				K_PlayPowerGloatSound(player.mo)
				S_ChangeMusic("HQSUPR", true, player)
			end
		end
		MasterEmeraldSyncer(player)

		if partner.player.exiting and not player.exiting then
			P_DoPlayerExit(player) -- Allow me to save replays pls :v
			
			-- fuck it
			player.pflags = $ & ~PF_TIMEOVER
			player.lives = 1
			player.deadtimer = 0
			player.kartstuff[k_respawn] = 0
			player.exiting = partner.player.exiting
			if not player.mo.signspawned then
				local exitsign = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+(mapobjectscale*400),MT_SIGN)
				exitsign.target = player.mo
				exitsign.state = S_SIGN1
				exitsign.movefactor = player.mo.floorz
				exitsign.movecount = 1
				player.mo.signspawned = true
			end
		end
	end
end

local function HandleRespawnSync(mobj, player, skipangle)
	-- kill all our momentum
	mobj.momx, mobj.momy, mobj.momz = 0, 0, 0
	-- set our angle
	if not skipangle then
		mobj.angle = player.mo.angle
	end
	-- respawn stuff
	mobj.player.combi_respawn = true
	player.combi_respawn = true
	player.mo.color = player.skincolor
	player.mo.colorized = false
	mobj.color = mobj.player.skincolor
	mobj.colorized = false
end

hcombi.YankRespawnThink = function(player, has_partner)
	local partner = hcombi.ReturnPartner(player)
	local plymo = player.mo
	
	// if we already have our pull hook set, and returns true, override everything
	if (hookLib.RunHook("CombiRespawn", partner, plymo))
		-- overwrite behaviour
		return
	end
	
	local yank_xy = FixedDiv(partner.pull_xy, plymo.pull_xy+partner.pull_xy)/4
	local yank_z = FixedDiv(partner.pull_z, plymo.pull_xy+partner.pull_z)/4
	
	if not has_partner then
		if player.kartstuff[k_respawn] then
			if (not player.combi_respawn) or (player.mo.momz > -3*mapscale and player.mo.z - player.mo.floorz > 20*mapscale) then
				local dist = FixedMul(mapscale, 60)
					
				// Let players shift sideways while respawning if they hold drift?
				if player.cmd.buttons & BT_DRIFT then
					local speed = player.cmd.driftturn/100
					P_TryMove(player.mo, player.mo.x - sin(player.mo.angle)*speed, player.mo.y + cos(player.mo.angle)*speed, true)
				end
				
				player.combi_respawn = true
					
				P_SetOrigin(partner, player.mo.x, player.mo.y, player.mo.z + 100*mapscale)
				partner.momx, partner.momy, partner.momz = 0, 0, 0
				partner.angle = player.mo.angle
				
				return
			end
		else
			player.combi_respawn = false
		end
		return
	end
	
	local addi = 100*mapscale
	local addi_p = 100*mapscale
	if player.kartstuff[k_starpostflip] then
		addi = (100*mapscale) * -1
	end
	if partner.player.kartstuff[k_starpostflip] then
		addi_p = (100*mapscale) * -1
	end
	
	-- sync our respawn timer
	player.kartstuff[k_respawn] = max($, partner.player.kartstuff[k_respawn])
	
	if not player.kartstuff[k_respawn] then
		partner.player.kartstuff[k_respawn] = 0
		player.combi_respawn = false 
		partner.player.combi_respawn = false 
	end
	
	if player.kartstuff[k_respawn] and (partner.player.kartstuff[k_respawn] ~= 48 or partner.player.kartstuff[k_respawn] ~= 47) and not partner.player.combi_respawn then
		-- check if we have gotten a starpoint
		-- we need to so that we respawn at the right spot
		if player.starpostnum and player.starpostnum > 0 then
			P_SetOrigin(player.mo, player.starpostx*FRACUNIT, player.starposty*FRACUNIT, (player.starpostz*FRACUNIT) + addi)
			player.mo.angle = player.starpostangle
		else
			P_SetOrigin(player.mo, player.startposition[1], player.startposition[2], player.startposition[3] + addi)
			player.mo.angle = player.startposition[4]
		end
		-- teleport our partner to where we are
		P_SetOrigin(partner, player.mo.x, player.mo.y, player.mo.z + addi)
		-- handle everything else lmao
		HandleRespawnSync(partner, player)
	end
	
	if player.kartstuff[k_respawn] > 1 then
		HandleRespawnSync(partner, player, true)
	end
	
	if player.deadtimer > 1 then
		if (leveltime % 2) == 0 then
			partner.player.mo.color = SKINCOLOR_RED
			partner.player.mo.colorized = true
		else
			partner.player.mo.color = partner.player.skincolor
			partner.player.mo.colorized = false
		end
		-- kill all our momentum
		partner.momx, partner.momy, partner.momz = 0, 0, 0
	end
	
	if player.kartstuff[k_respawn] == 48 or player.kartstuff[k_respawn] == 47 then
		player.mo.color = player.skincolor
		player.mo.colorized = false
	end
	
	if partner.player.kartstuff[k_respawn] and (player.kartstuff[k_respawn] ~= 48 or player.kartstuff[k_respawn] ~= 47) and not player.combi_respawn then
		-- check if we have gotten a starpoint
		-- we need to so that we respawn at the right spot
		if partner.player.starpostnum and partner.player.starpostnum > 0 then
			P_SetOrigin(partner, partner.player.starpostx*FRACUNIT, partner.player.starposty*FRACUNIT, (partner.player.starpostz*FRACUNIT) + addi_p)
			partner.angle = partner.player.starpostangle
		else
			P_SetOrigin(partner, partner.player.startposition[1], partner.player.startposition[2], partner.player.startposition[3] + addi_p)
			partner.angle = partner.player.startposition[4]
		end
		-- teleport our partner to where we are
		P_SetOrigin(player.mo, partner.x, partner.y, partner.z + addi_p)
		-- handle everything else lmao
		HandleRespawnSync(player.mo, partner.player)
	end
end

local endtime = (5*TICRATE+TICRATE/2) + TICRATE/4

-- terrible name, i know.
local function CheckLESpecialWithinLESector(sector, special)
	if not sector.tag then return end -- why bother?
	local found_it = false
	local li = nil
	for line in lines.iterate do
		if line.tag == sector.tag then -- we found a linedef with a tag associated to a sector!
			li = line
			break
		end
	end
	if li ~= nil then -- check for a specific linedef special
		local ex_sector = li.frontsector
		for i=0,#ex_sector.lines,1 do
			if ex_sector.lines[i] and ex_sector.lines[i].special and ex_sector.lines[i].special == special then -- we found it!
				found_it = true
				break
			end
		end
	end
	return found_it
end

local function TeleporterBullshit(player, partner)
	local addi = 100*mapscale
	local addi_p = 100*mapscale
	if player.mo.eflags & MFE_VERTICALFLIP then
		addi = (100*mapscale) * -1
	end
	if partner.eflags & MFE_VERTICALFLIP then
		addi_p = (100*mapscale) * -1
	end
	
	local current_sector = player.mo.subsector.sector
	if current_sector == nil then return false end
	local result = CheckLESpecialWithinLESector(current_sector, 412)
	if result then
		P_SetOrigin(partner, player.mo.x, player.mo.y, player.mo.z + addi)
		player.kartstuff[k_hyudorotimer] = TICRATE
		if partner.player then
			partner.player.kartstuff[k_hyudorotimer] = TICRATE
		end
		partner.momx, partner.momy, partner.momz = 0, 0, 0
		player.mo.momx, player.mo.momy, player.mo.momz = 0, 0, 0
		partner.angle = player.mo.angle
		return true
	end
	current_sector = partner.subsector.sector
	if current_sector == nil then return false end
	result = CheckLESpecialWithinLESector(current_sector, 412)
	if result then
		P_SetOrigin(player.mo, partner.x, partner.y, partner.z + addi_p)
		player.kartstuff[k_hyudorotimer] = TICRATE
		if partner.player then
			partner.player.kartstuff[k_hyudorotimer] = TICRATE
		end
		player.mo.momx, player.mo.momy, player.mo.momz = 0, 0, 0
		partner.momx, partner.momy, partner.momz = 0, 0, 0
		player.mo.angle = partner.angle
		return true
	end
	return false
end

local function OldTeleporterBullshit(player, partner, distance)
	if (distance > 700*mapscale) then 
		if partner.player and partner.player.deadtimer > 1 then return end
		if partner.player then 
			if partner.player.combi_respawn or player.combi_respawn then
				return 
			end
		end
		if not has_partner and player.deadtimer > 1 then return end
		partner.momx, partner.momy, partner.momz = 0, 0, 0
		partner.angle = player.mo.angle
		if partner.player ~= nil then
			partner.player.powers[pw_flashing] = 0
			partner.player.powers[pw_nocontrol] = 0
		end
		P_SetOrigin(partner, player.mo.x, player.mo.y, player.mo.z) 
		return true
	end
	return false
end

hcombi.DistanceThink = function(player, has_partner)
	local partner = hcombi.ReturnPartner(player)
	local plymo = player.mo
	
	// if we already have our pull hook set, and returns true, override everything
	if (hookLib.RunHook("CombiDistance", partner, plymo))
		-- overwrite behaviour
		return
	end
	
	local yank_xy = FixedDiv(partner.pull_xy, plymo.pull_xy+partner.pull_xy)/4
	local yank_z = FixedDiv(partner.pull_z, plymo.pull_xy+partner.pull_z)/4
	
	local distance = FixedHypot(FixedHypot(player.mo.x - partner.x, player.mo.y - partner.y), player.mo.z - partner.z)

	if distance < MAX_DISTANCE then return end
	-- TELEPORT SPOOF
	-- no more gettiing stuck between the teleporters at orr
	-- or monster monarch
	-- or cosmic eclipse
	-- or literally any map that has a teleporter
	if OldTeleporterBullshit(player, partner, distance) then return end
	
	if partner.player and partner.player.deadtimer > 1 then return end
	if not has_partner and player.deadtimer > 1 then return end 

	distance = $-MAX_DISTANCE
		
	local angle = R_PointToAngle2(player.mo.x, player.mo.y, partner.x, partner.y)
	local v_angle = R_PointToAngle2(0, player.mo.z, R_PointToDist2(player.mo.x, player.mo.y, partner.x, partner.y), partner.z)

	P_Thrust(player.mo, angle, FixedMul(FixedMul(cos(v_angle), yank_xy), distance))
	player.mo.momz = $+FixedMul(FixedMul(sin(v_angle), yank_z), distance)
		
	if not has_partner then
		P_Thrust(partner, angle, -FixedMul(FixedMul(cos(v_angle), FRACUNIT-yank_xy), distance))
		partner.momz = $-FixedMul(FixedMul(sin(v_angle), FRACUNIT-yank_z), distance)
	end
	
	-- Make tugs at the start of the race less crazy
	if leveltime < endtime + TICRATE then
		player.mo.momx = $/3
		player.mo.momy = $/3
	end
end

hcombi.MiscellaneousThinker = function()
	for player in players.iterate do
		-- when a player spectates after partners have been assigned, just summon a gargoyle
		if player.combi == nil then 
			player.combi_p = {name = "anti-loneliness gargoyle", valid = false, mo = player.gargoyle}
			player.has_partner = false
			continue 
		end
		player.combi_p = players[player.combi]
		if player.combi ~= nil then
			if player.combi_p and (player.combi_p.pflags & PF_TIMEOVER or player.combi_p.spectator) then
				player.combi_p.combi = nil
				player.combi = nil
			end
		end
		if player.combi_p == nil or player.combi_p.mo == nil then hcombi.RemoveRingBit(player) player.combi = nil continue end
	end
end

hcombi.CheckpointThinker = function()
	for player in players.iterate do
		if not (player.mo and player.mo.valid) then continue end
		// we do not have gargoyle
		if not (player.combi_p and player.combi_p.valid) then continue end
		
		local partner = player.combi_p
		
		// section race stuff
		if (mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE) then 
			if player.laps < partner.laps then
				player.startposition = {player.mo.x, player.mo.y, player.mo.z, player.mo.angle}
				partner.startposition = {player.mo.x, player.mo.y, player.mo.z, player.mo.angle}
			end
		end
		
		// sync checkpoint positions and laps
		if player.laps < partner.laps then
			player.starpostnum = 0
			partner.starpostnum = 0
			player.laps = partner.laps
		end
		if (partner.starpostnum or player.starpostnum) and partner.starpostnum > player.starpostnum then
			player.starpostnum = partner.starpostnum
			player.starpostx = partner.starpostx
			player.starposty = partner.starposty
			player.starpostz = partner.starpostz
			player.starpostangle = partner.starpostangle
			player.starposttime = player.realtime //this makes race mode's timers work correctly whilst not affecting sp -x
			player.kartstuff[k_starpostflip] = partner.kartstuff[k_starpostflip]	// store flipping
			player.grieftime = 0
		end
		
		// SHUT THE FUCK UP you noisy ass i do not need to be reminded
		if S_SoundPlaying(player.mo, sfx_s26d) then
			S_StopSoundByID(player.mo, sfx_s26d)
		end
		
		player.oldcombilaps = player.laps
	end
end

hcombi.modScroll = 0

local function GetMaxPlayers()
	local pingame = 0
	for player in players.iterate do
		if player.spectator then continue end
		if not player.mo and not player.mo.valid then continue end
		
		pingame = $ + 1
	end
	
	return pingame
end

hcombi.PartnerScroll = function()
	if leveltime == 2 then
		--print("reset goes here")
		// cache this shit at the start
		hcombi.leveltime_on = hcombi.enabled.value
		hcombi.initscroll = -2*TICRATE
		hcombi.modScroll = 0
		hcombi.numteams = 0
		for player in players.iterate do
			player.fake_combi = player
			player.old_combi = player
			player.combi_friend = hcombi.frens_allowed.value and player.hcombifrennum or 0
			player.combi = nil
			player.has_partner = false
			if player.mo and player.mo.valid then
				player.startposition = {player.mo.x, player.mo.y, player.mo.z, player.mo.angle}
			end
		end
	elseif not hcombi.leveltime_on then
		return
	elseif leveltime < endtime and leveltime > 2 then
		--if leveltime == START_TIME then S_StartSound(nil, sfx_token) end
		hcombi.initscroll = $ - min((endtime - leveltime)*2/5, TICRATE*2)
		if hcombi.initscroll < 0 then
			hcombi.initscroll = $ + TICRATE*6
			--print(hcombi.initscroll)
		else
			return
		end
		
		-- combi roulette emulation
		local allPlayers = {}
		for player in players.iterate do
			if player.mo and player.mo.valid then
				player.old_combi = player.fake_combi
				if player.combi_friend and players[player.combi_friend-1].valid and 
					players[player.combi_friend-1].mo and players[player.combi_friend-1].mo.valid and 
					players[player.combi_friend-1].combi_friend and players[player.combi_friend-1].combi_friend-1 == #player then
					player.fake_combi = players[player.combi_friend-1]
					player.combi = player.combi_friend-1
					player.has_partner = true
				else
					table.insert(allPlayers, player)
				end
			else
				player.fake_combi = player
			end
		end
		
		-- oh hey
		while #allPlayers >= 2 do
			local one, two
			-- apparently jart doesnt want these separate or itll screem
			one = table.remove(allPlayers, KR_RandomRange(1,#allPlayers))
			two = table.remove(allPlayers, KR_RandomRange(1,#allPlayers))
			-- these work, apparently.
			local rnd1 = #one
			local rnd2 = #two
			
			-- fake combi is for other stuff
			one.fake_combi = two
			two.fake_combi = one
			
			hcombi.numteams = $ + 1

			one.combi = rnd2
			two.combi = rnd1
			one.combi_p = players[one.combi]
			two.combi_p = players[two.combi]
			one.has_partner = true
			two.has_partner = true
		end
		
		-- we are odd!!!!!!!!!!!!
		if #allPlayers then
			allPlayers[1].fake_combi = {valid = false, name = "---"}
			allPlayers[1].combi = nil
			allPlayers[1].has_partner = false
		end
		
		-- gargoyle only
		if GetMaxPlayers() < hcombi.minimumplayers.value then
			for player in players.iterate do
				player.fake_combi = {valid = false, name = "---"}
				player.combi = nil
				player.has_partner = false
			end
		end
		
		S_StartSound(nil, sfx_s1ba)
	end
end

local starttime = 6 * TICRATE + (3 * TICRATE / 4)

local premadevalues = {
	[962] = "STTRU" -- KanzakiPak's "Climb the Stairs" (Two Trucks in the SM64 Soundfont)
}

addHook("PostThinkFrame", function()
	if not hcombi.leveltime_on then return end
	
	-- theres 1 tick of delay with COM_BufInsertText
	if leveltime ~= (starttime + (TICRATE/2)) - 1 then return end
	
	if mapheaderinfo[gamemap].combimusic or premadevalues[gamemap] then			
		if premadevalues[gamemap] then
			COM_BufInsertText(consoleplayer, "tunes "..premadevalues[gamemap])
		else
			COM_BufInsertText(consoleplayer, "tunes "..mapheaderinfo[gamemap].combimusic)
		end
	end
end)

local function COMBI_NoContestPlayer(player)
	player.exiting = 0
	player.lives = 0
	player.pflags = $|PF_TIMEOVER
	player.mo.flags = $|MF_NOGRAVITY|MF_NOCLIP
	player.mo.flags2 = $|MF2_DONTDRAW
	-- hm...
	player.kartstuff[k_position] = GetMaxPlayers()
	SetPowerInfo(player, false, 0)
	SetPowerInfo(player, true, 0)
	P_DamageMobj(player.mo, nil, nil, 10000)
	-- rub it in
	COM_BufInsertText(player, "tunes KRFAIL")
	
	-- spawn KABOOM because it doesnt spawn one
	local boom = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_FZEROBOOM)
	boom.scale = player.mo.scale
	boom.angle = player.mo.angle
	-- disappear over time
	boom.fuse = 10*TICRATE
end

local cv_karteliminatelast
addHook("PreThinkFrame", function()
	if cv_karteliminatelast == nil then
		cv_karteliminatelast = CV_FindVar("karteliminatelast")
	end
	
	-- no
	if leveltime < 5 then return end
	if cv_karteliminatelast.value == 1 then
		-- nope
		CV_StealthSet(cv_karteliminatelast, 0)
		-- goodbye world
		CONS_Printf(server, "\x82".."WARNING:".."\x80".." Use combieliminatelast instead of karteliminatelast.")
		-- redirect
		CV_StealthSet(hcombi.combieliminatelast, 1)
	end
end)

rawset(_G, "combi_maxteams", function()
	if not hcombi.leveltime_on then return 0 end
	return hcombi.numteams
end)

-- last combi team dies when combieliminatelast is on
addHook("PostThinkFrame", function()
	local pingame = 0
	for player in players.iterate do
		-- die monster
		if player.spectator then continue end
		if not player.mo and not player.mo.valid then continue end
		if player.exiting then continue end
		if not player.lives then continue end
		
		pingame = $ + 1
	end
	
	-- combi
	if hcombi.leveltime_on and hcombi.combieliminatelast.value == 1 then
		if pingame <= 2 and GetMaxPlayers() > 2 then
			for player in players.iterate do
				if player.spectator then continue end
				if not player.mo and not player.mo.valid then continue end
				if player.exiting then continue end
				if not player.lives then continue end
				
				COMBI_NoContestPlayer(player)
				if player.has_partner then
					COMBI_NoContestPlayer(player.combi_p)
				end
			end
		end
		return
	end
	
	-- vanilla behavior
	if hcombi.combieliminatelast.value == 1 then
		if pingame <= 1 and GetMaxPlayers() > 1 then
			for player in players.iterate do
				if player.spectator then continue end
				if not player.mo and not player.mo.valid then continue end
				if player.exiting then continue end
				if not player.lives then continue end
				
				COMBI_NoContestPlayer(player)
			end
		end
		return
	end
end)

addHook("ThinkFrame", function()
	-- do not execute ANYTHING here when combi is not on.
	if leveltime == 2 then
		hcombi.leveltime_on = hcombi.enabled.value
		for p in players.iterate do
			if (p and p.valid) then
				-- NUKE
				p.combi = nil
				p.combi_p = nil
			end
		end
	end
	if not hcombi.leveltime_on then return end
	
	-- Taken from RetroStation's KartVR rival system (thanks to RetroStation for this btw!)
	-- I just needed an excuse to not use cvars
	for p in players.iterate do
		if (p and p.valid) then
			if not (p.hcombifrenpending and players[p.hcombifrenpending-1] and players[p.hcombifrenpending-1].valid) then
				p.hcombifrenpending = 0
			end
			
			if hcombi_playercount() > 1 then
				if p.hcombifren ~= "none"
				and not p.hcombifrenpending then
					for q in players.iterate do
						if q.name == p.hcombifrenpending then
							p.hcombifrenpending = #q + 1
						end
					end
				end
				
				if p.hcombifrenpending and players[p.hcombifrenpending-1].hcombifrenpending-1 == #p then
					p.hcombifren = tostring(players[p.hcombifrenpending-1].name)
					p.hcombifrennum = p.hcombifrenpending
					p.hcombihasfren = 1
				end
			end
		end
	end
	hcombi.PartnerScroll()
	hcombi.MiscellaneousThinker()
	hcombi.CheckpointThinker()
	if leveltime < endtime then return end
	hcombi.initscroll = $/2
	if leveltime == endtime then S_StartSound(nil, sfx_token) end
	
	-- ok now we're here, lets talk a bit about fickle's combi mod.
	-- desyncs are prevalent when using this in replays, as it has a lot of problems.
	-- i would normally just fix it but it is non reusable
	
	-- this uses some of the code from fickle's but it is not a direct edit.
	-- this is somewhat of a reimplementation and fixes some of the original's quirks.
	-- otherwise this doesnt differ all too much
	
	-- fickle if youre reading this thank you for the amount of chaos you have brought to this community
	
	-- max thanks to bladesinger from kru for doing a small combi ring marathon
	-- i wouldnt have thought of this without you man
	
	-- - haya

	mapscale = mapobjectscale
	MAX_DISTANCE = BASE_DISTANCE * mapscale
	
	for player in players.iterate do
		if player.spectator then continue end
		hcombi.RingBitThink(player, player.has_partner)
		hcombi.PullVarThink(player, player.has_partner)
		hcombi.PlayerDataThink(player, player.has_partner)
		hcombi.YankRespawnThink(player, player.has_partner)
		hcombi.DistanceThink(player, player.has_partner)
	end
end)

-- Make rankings display per pair instead of per individual?
addHook("ThinkFrame", do
	if not hcombi.leveltime_on then return end

	local individual_rank = {}
	--print("---------------")
	for player in players.iterate do
		player.combi_rank = nil
		if not player.spectator then
			--print(player.real_rank)
			player.real_rank = $ or player.kartstuff[k_position]
			
			local spot = 1
			while individual_rank[spot] and individual_rank[spot].real_rank <= player.real_rank do
				spot = $+1
			end

			table.insert(individual_rank, spot, player)
		end
	end
	
	local rank = 1
	local team_rank = 0
	
	while individual_rank[rank] do
		local player = individual_rank[rank]
		player.real_rank = nil
		if player.combi ~= nil and players[player.combi] and players[player.combi].valid and players[player.combi].combi_rank then
			player.combi_rank = players[player.combi].combi_rank
		else
			team_rank = $+1
			player.combi_rank = team_rank
		end
		
		if player.combi_rank ~= player.old_combi_rank then
			player.combi_rank_cooldown = 10
			player.old_combi_rank = player.combi_rank
		elseif player.combi_rank_cooldown > 0 then
			player.combi_rank_cooldown = $-1
		end
		
		-- This handles HUD display of the ranking, I think!
		player.kartstuff[k_position] = player.combi_rank
		player.kartstuff[k_positiondelay] = player.combi_rank_cooldown
		
		rank = $+1
	end
end)

-- Force rankings to be mostly-correct on player thinkers. This causes the distance-checking code for giving SPBs to work properly.
addHook("MobjThinker", do
	if not hcombi.leveltime_on then return end
	
	--print("-----")
	for player in players.iterate do
		-- This "real_rank" juggling is necessary to make sure we don't break the team position display.
		if not player.real_rank then
			player.real_rank = player.kartstuff[k_position]
		end

		if player.combi_rank then
			player.kartstuff[k_position] = player.combi_rank
		end
	end
end, MT_PLAYER)

local function DetectPartnerCollision(thing, thing2)
	if not hcombi.leveltime_on then return end
	if hcombi.friendlyfire.value then return end -- friendly fire on
	-- make sure its actually a player
	if (thing and thing.valid and thing.player and thing.player.valid)
		if (thing2 and thing2.valid)
			if ((thing2.type == MT_ORBINAUT) 
				or (thing2.type == MT_ORBINAUT_SHIELD) 
				or (thing2.type == MT_JAWZ) 
				or (thing2.type == MT_JAWZ_DUD) 
				or (thing2.type == MT_JAWZ_SHIELD)
				or (thing2.type == MT_ORBINAUT)
				or (thing2.type == MT_ORBINAUT_SHIELD)
				or (thing2.type == MT_JAWZ)
				or (thing2.type == MT_JAWZ_SHIELD)
				or (thing2.type == MT_JAWZ_DUD)
				or (thing2.type == MT_BALLHOG)
				or (thing2.type == MT_BANANA)
				or (thing2.type == MT_BANANA_SHIELD)
				or (thing2.type == MT_EGGMANITEM)
				or (thing2.type == MT_EGGMANITEM_SHIELD) 
				or (thing2.flags&MF_MISSILE) or (thing2.flags&MF_ENEMY) or (thing2.flags&MF_FIRE) or (thing2.flags&MF_PAIN))
				and (thing2.target and thing2.target.valid)
				and (thing2.target.player and thing2.target.player.valid)
				and (thing2.target.player == thing.player.combi_p)
					return false
			end
		end
	end
	return
end

addHook("ShouldDamage", function(mo, inflictor, source, damage)
	if not hcombi.leveltime_on then return end
	if hcombi.friendlyfire.value then return end -- friendly fire on
    if not (mo and mo.valid and mo.player) then return end
	local mop, mopks = mo.player, mo.player.kartstuff
    if damage < 10000 then
		if inflictor 
		and inflictor.valid 
		and inflictor.player then
			if (inflictor.player.kartstuff[k_curshield] == 1) 
			and inflictor.player == players[mop.combi] then
				return false
			end
		end
	end
end)

addHook("ShouldSpin", function(p, inflictor,source)
	if not hcombi.leveltime_on then return end
	if hcombi.friendlyfire.value then return end -- friendly fire on
	if inflictor 
	and inflictor.valid 
	and inflictor.player then
		if (inflictor.player.kartstuff[k_curshield] == 1) 
		and inflictor.player == players[p.combi] then
			return false
		end
	end
end)

local function FuckGargoyles(thing, thing2)
	if not hcombi.leveltime_on then return end
	if thing and thing.valid then
		if thing2 and thing2.valid then
			if thing.target == thing2 then 
				if thing2.player and thing2.player.valid then
					-- allow players to bonk their own gargoyle
					if thing2.player.cmd.buttons & BT_CUSTOM3 then return end
				end
				return false 
			end
			if thing2.player and thing2.player.valid then
				return
			end
		end
	end
	return false
end

local function FuckGargoylesPlayerSide(thing, thing2)
	if not hcombi.leveltime_on then return end
	if thing and thing.valid then
		if thing2 and thing2.valid then
			if thing2.target == thing and thing2.type == MT_GARGOYLE then 
				if thing.player and thing.player.valid then
					-- allow players to bonk their own gargoyle
					if thing.player.cmd.buttons & BT_CUSTOM3 then return end
					return false 
				end
			end
		end
	end
	return
end

addHook("MobjCollide", FuckGargoyles, MT_GARGOYLE)
addHook("MobjMoveCollide", FuckGargoyles, MT_GARGOYLE)

addHook("MobjCollide", FuckGargoylesPlayerSide, MT_PLAYER)
addHook("MobjMoveCollide", FuckGargoylesPlayerSide, MT_PLAYER)

-- prevents shooting your own teammate
local function CombiJawzRehandler(player)
	if not hcombi.leveltime_on then return end
	if hcombi.friendlyfire.value then return end -- friendly fire on
	player.combijawztarget = $ or player.kartstuff[k_lastjawztarget]
	if (player.kartstuff[k_itemtype] == KITEM_JAWZ and player.kartstuff[k_itemheld]) then
		local lasttarg = player.combijawztarget
		local targ = nil
		
		if (player.kartstuff[k_jawztargetdelay] and not (players[lasttarg].spectator or (players[lasttarg].combi_p == player or player.combi_p == players[lasttarg]))) then
			targ = players[lasttarg]
			player.kartstuff[k_jawztargetdelay] = $ - 1
		else
			targ = K_FindJawzTarget(player.mo, player)
		end
			
		if (not targ or not targ.mo) then
			player.combijawztarget = -1
			player.kartstuff[k_jawztargetdelay] = 0
			return
		end
		
		if (#targ != lasttarg) then
			S_StartSound(targ.mo, sfx_s3k89)

			player.combijawztarget = #targ
			player.kartstuff[k_jawztargetdelay] = 5
		end
	else
		player.combijawztarget = -1
		player.kartstuff[k_jawztargetdelay] = 0
	end
	
	player.kartstuff[k_lastjawztarget] = player.combijawztarget
end

-- p-p-p-post
addHook("PostThinkFrame", function()
	if not hcombi.leveltime_on then return end
	for p in players.iterate do
		CombiJawzRehandler(p)
	end
end)

addHook("MobjCollide", DetectPartnerCollision, MT_PLAYER)
addHook("MobjMoveCollide", DetectPartnerCollision, MT_PLAYER)
